Loading...
Searching...
No Matches
juce::MidiKeyboardComponent Class Reference

## Detailed Description

A component that displays a piano keyboard, whose notes can be clicked on.

This component will mimic a physical midi keyboard, showing the current state of a MidiKeyboardState object. When the on-screen keys are clicked on, it will play these notes by calling the noteOn() and noteOff() methods of its MidiKeyboardState object.

Another feature is that the computer keyboard can also be used to play notes. By default it maps the top two rows of a standard qwerty keyboard to the notes, but these can be remapped if needed. It will only respond to keypresses when it has the keyboard focus, so to disable this feature you can call setWantsKeyboardFocus (false).

The component is also a ChangeBroadcaster, so if you want to be informed when the keyboard is scrolled, you can register a ChangeListener for callbacks.

See also
  MidiKeyboardState

The documentation for this class was generated from the following file:

- juce_audio_utils/gui/juce_MidiKeyboardComponent.h

Inheritance diagram for juce::MidiKeyboardComponent:

## Public Types

enum | ColourIds { whiteNoteColourId = 0x1005000 , blackNoteColourId = 0x1005001 , keySeparatorLineColourId = 0x1005002 , mouseOverKeyOverlayColourId = 0x1005003 , keyDownOverlayColourId = 0x1005004 , textLabelColourId = 0x1005005 , shadowColourId = 0x1005006 }
| A set of colour IDs to use to change the colour of various aspects of the keyboard. More...
Public Types inherited from juce::KeyboardComponentBase
enum | Orientation { horizontalKeyboard , verticalKeyboardFacingLeft , verticalKeyboardFacingRight }
| The direction of the keyboard. More...
enum | ColourIds { upDownButtonBackgroundColourId = 0x1004000 , upDownButtonArrowColourId = 0x1004001 }
| Colour IDs to use to change the colour of the octave scroll buttons. More...
Public Types inherited from juce::Component
enum class | WindowControlKind { client , caption , minimise , maximise , close , sizeTop , sizeLeft , sizeRight , sizeBottom , sizeTopLeft , sizeTopRight , sizeBottomLeft , sizeBottomRight }
| Types of control that are commonly found in windows, especially title-bars. More...
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...
enum class | FocusChangeDirection { unknown , forward , backward }
| Enumeration used by the focusGainedWithDirection() method. More...

## Public Member Functions

| MidiKeyboardComponent (MidiKeyboardState &state, Orientation orientation)
| Creates a MidiKeyboardComponent.
| ~MidiKeyboardComponent () override
| Destructor.
void | setVelocity (float velocity, bool useMousePositionForVelocity)
| Changes the velocity used in midi note-on messages that are triggered by clicking on the component.
void | setMidiChannel (int midiChannelNumber)
| Changes the midi channel number that will be used for events triggered by clicking on the component.
int | getMidiChannel () const noexcept
| Returns the midi channel that the keyboard is using for midi messages.
void | setMidiChannelsToDisplay (int midiChannelMask)
| Sets a mask to indicate which incoming midi channels should be represented by key movements.
int | getMidiChannelsToDisplay () const noexcept
| Returns the current set of midi channels represented by the component.
void | clearKeyMappings ()
| Deletes all key-mappings.
void | setKeyPressForNote (const KeyPress &key, int midiNoteOffsetFromC)
| Maps a key-press to a given note.
void | removeKeyPressForNote (int midiNoteOffsetFromC)
| Removes any key-mappings for a given note.
void | setKeyPressBaseOctave (int newOctaveNumber)
| Changes the base note above which key-press-triggered notes are played.
virtual void | drawWhiteNote (int midiNoteNumber, Graphics &g, Rectangle< float > area, bool isDown, bool isOver, Colour lineColour, Colour textColour)
| Use this method to draw a white note of the keyboard in a given rectangle.
virtual void | drawBlackNote (int midiNoteNumber, Graphics &g, Rectangle< float > area, bool isDown, bool isOver, Colour noteFillColour)
| Use this method to draw a black note of the keyboard in a given rectangle.
virtual bool | mouseDownOnKey (int midiNoteNumber, const MouseEvent &e)
| Callback when the mouse is clicked on a key.
virtual bool | mouseDraggedToKey (int midiNoteNumber, const MouseEvent &e)
| Callback when the mouse is dragged from one key onto another.
virtual void | mouseUpOnKey (int midiNoteNumber, const MouseEvent &e)
| Callback when the mouse is released from a key.
virtual String | getWhiteNoteText (int midiNoteNumber)
| Allows text to be drawn on the white notes.
void | mouseMove (const MouseEvent &) override
| Called when the mouse moves inside a component.
void | mouseDrag (const MouseEvent &) override
| Called when the mouse is moved while a button is held down.
void | mouseDown (const MouseEvent &) override
| Called when a mouse button is pressed.
void | mouseUp (const MouseEvent &) override
| Called when a mouse button is released.
void | mouseEnter (const MouseEvent &) override
| Called when the mouse first enters a component.
void | mouseExit (const MouseEvent &) override
| Called when the mouse moves out of a component.
void | timerCallback () override
| The user-defined callback routine that actually gets called periodically.
bool | keyStateChanged (bool isKeyDown) override
| Called when a key is pressed or released.
bool | keyPressed (const KeyPress &) override
| Called when a key is pressed.
void | focusLost (FocusChangeType) override
| Called to indicate that this component has just lost the keyboard focus.
void | colourChanged () override
| This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChange() methods.
Public Member Functions inherited from juce::KeyboardComponentBase
| KeyboardComponentBase (Orientation orientation)
| Constructor.
| ~KeyboardComponentBase () override=default
| Destructor.
void | setKeyWidth (float widthInPixels)
| Changes the width used to draw the white keys.
float | getKeyWidth () const noexcept
| Returns the width that was set by setKeyWidth().
void | setScrollButtonWidth (int widthInPixels)
| Changes the width used to draw the buttons that scroll the keyboard up/down in octaves.
int | getScrollButtonWidth () const noexcept
| Returns the width that was set by setScrollButtonWidth().
void | setOrientation (Orientation newOrientation)
| Changes the keyboard's current direction.
Orientation | getOrientation () const noexcept
| Returns the keyboard's current direction.
bool | isHorizontal () const noexcept
| Returns true if the keyboard's orientation is horizontal.
void | setAvailableRange (int lowestNote, int highestNote)
| Sets the range of midi notes that the keyboard will be limited to.
int | getRangeStart () const noexcept
| Returns the first note in the available range.
int | getRangeEnd () const noexcept
| Returns the last note in the available range.
void | setLowestVisibleKey (int noteNumber)
| If the keyboard extends beyond the size of the component, this will scroll it to show the given key at the start.
int | getLowestVisibleKey () const noexcept
| Returns the number of the first key shown in the component.
float | getWhiteNoteLength () const noexcept
| Returns the absolute length of the white notes.
void | setBlackNoteLengthProportion (float ratio) noexcept
| Sets the length of the black notes as a proportion of the white note length.
float | getBlackNoteLengthProportion () const noexcept
| Returns the length of the black notes as a proportion of the white note length.
float | getBlackNoteLength () const noexcept
| Returns the absolute length of the black notes.
void | setBlackNoteWidthProportion (float ratio) noexcept
| Sets the width of the black notes as a proportion of the white note width.
float | getBlackNoteWidthProportion () const noexcept
| Returns the width of the black notes as a proportion of the white note width.
float | getBlackNoteWidth () const noexcept
| Returns the absolute width of the black notes.
void | setScrollButtonsVisible (bool canScroll)
| If set to true, then scroll buttons will appear at either end of the keyboard if there are too many notes to fit them all in the component at once.
float | getKeyStartPosition (int midiNoteNumber) const
| Returns the position within the component of the left-hand edge of a key.
float | getTotalKeyboardWidth () const noexcept
| Returns the total width needed to fit all the keys in the available range.
NoteAndVelocity | getNoteAndVelocityAtPosition (Point< float > position, bool includeChildComponents=false)
| Returns the note number and velocity for a given position within the component.
Rectangle< float > | getRectangleForKey (int midiNoteNumber) const
| Returns the rectangle for a given key.
void | setOctaveForMiddleC (int octaveNumForMiddleC)
| This sets the octave number which is shown as the octave number for middle C.
int | getOctaveForMiddleC () const noexcept
| This returns the value set by setOctaveForMiddleC().
virtual void | drawUpDownButton (Graphics &g, int w, int h, bool isMouseOver, bool isButtonPressed, bool movesOctavesUp)
| This can be overridden to draw the up and down buttons that scroll the keyboard up/down in octaves.
virtual Range< float > | getKeyPosition (int midiNoteNumber, float keyWidth) const
| Calculates the position of a given midi-note.
void | paint (Graphics &) override
| Components can override this method to draw their content.
void | resized () override
| Called when this component's size has been changed.
void | mouseWheelMove (const MouseEvent &, const MouseWheelDetails &) override
| Called when the mouse-wheel is moved.
Public Member Functions inherited from juce::Component
| Component () noexcept
| Creates a component.
| ~Component () override
| Destructor.
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time.
String | getName () const noexcept
| Returns the name of this component.
virtual void | setName (const String &newName)
| Sets the name of this component.
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID().
void | setComponentID (const String &newID)
| Sets the component's ID string.
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible.
bool | isVisible () const noexcept
| Tests whether the component is visible or not.
virtual void | visibilityChanged ()
| Called when this component's visibility changes.
bool | isShowing () const
| Tests whether this component and all its parents are visible.
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop.
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it.
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop.
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component.
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window.
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised.
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop.
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings.
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings.
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component.
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings.
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings.
int | getX () const noexcept
| Returns the x coordinate of the component's left edge.
int | getY () const noexcept
| Returns the y coordinate of the top of this component.
int | getWidth () const noexcept
| Returns the component's width in pixels.
int | getHeight () const noexcept
| Returns the component's height in pixels.
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge.
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point.
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component.
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box.
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin.
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers.
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin.
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin.
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left.
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left.
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position.
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position.
void | setTopRightPosition (int x, int y)
| Moves the component to a new position.
void | setTopRightPosition (Point< int >)
| Moves the component to a new position.
void | setSize (int newWidth, int newHeight)
| Changes the size of the component.
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size.
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size.
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it.
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged.
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre.
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre.
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre.
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent.
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component.
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component.
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component.
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width.
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height.
int | getParentWidth () const noexcept
| Returns the width of the component's parent.
int | getParentHeight () const noexcept
| Returns the height of the component's parent.
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component.
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains.
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index.
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components.
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components.
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID.
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one.
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one.
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID.
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components.
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index.
void | removeAllChildren ()
| Removes all this component's children.
void | deleteAllChildren ()
| Removes and deletes all of this component's children.
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside.
template<class TargetClass>
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class.
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents.
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children.
virtual void | parentHierarchyChanged ()
| Called to indicate that the component's parents have changed.
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes.
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component.
virtual WindowControlKind | findControlAtPoint (Point< float >) const
| For components that are added to the desktop, this may be called to determine what kind of control is at particular locations in the window.
virtual void | windowControlClickedClose ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "close" control.
virtual void | windowControlClickedMinimise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "minimise" control.
virtual void | windowControlClickedMaximise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "maximise" control.
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method.
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags.
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one.
void | repaint ()
| Marks the whole component as needing to be redrawn.
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn.
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn.
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing.
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f, const ImageType &imageType=NativeImageType{})
| Generates a snapshot of part of this component.
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context.
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted.
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted.
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance.
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect.
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component.
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component.
FontOptions | withDefaultMetrics (FontOptions opt) const
| Returns a copy of the FontOptions with the default metrics kind from the component's LookAndFeel.
virtual void | lookAndFeelChanged ()
| Called to let the component react to a change in the look-and-feel setting.
void | sendLookAndFeelChange ()
| Calls the methods repaint(), lookAndFeelChanged(), and colourChanged() in this component and all its children recursively.
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent.
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent.
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked.
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on.
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component.
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified.
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports.
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container.
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container.
Component * | findFocusContainer () const
| Returns the focus container for this component.
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component.
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not.
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus.
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus.
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus().
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component.
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component.
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus.
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings.
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component.
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component.
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus.
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline.
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled.
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component.
virtual void | enablementChanged ()
| Callback to indicate that this component has been enabled or disabled.
float | getAlpha () const noexcept
| Returns the component's current transparency level.
void | setAlpha (float newAlpha)
| Changes the transparency of this component.
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component.
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component.
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component.
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated.
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children.
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component.
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used.
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component.
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component.
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener.
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives.
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener.
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released.
virtual void | focusGained (FocusChangeType cause)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusGainedWithDirection (FocusChangeType cause, FocusChangeDirection direction)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusOfChildComponentChanged (FocusChangeType cause)
| Called to indicate a change in whether or not this component is the parent of the currently-focused component.
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component.
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component.
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component.
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component.
virtual void | moved ()
| Called when this component's position has been changed.
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized.
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized.
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings.
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position.
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener.
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component.
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage().
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates.
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state.
void | exitModalState (int returnValue=0)
| Ends a component's modal state.
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one.
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages.
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events.
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component.
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component.
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component.
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number.
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose.
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it.
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method.
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component.
void * | getWindowHandle () const
| Returns the underlying native window handle for this component.
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component.
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component.
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting.
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage().
void | invalidateCachedImageResources ()
| Invalidates cached images, both in the CachedComponentImage (if any) and the image effect state.
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled.
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag.
String | getTitle () const noexcept
| Returns the title text for this component.
void | setTitle (const String &newTitle)
| Sets the title for this component.
String | getDescription () const noexcept
| Returns the description for this component.
void | setDescription (const String &newDescription)
| Sets the description for this component.
String | getHelpText () const noexcept
| Returns the help text for this component.
void | setHelpText (const String &newHelpText)
| Sets the help text for this component.
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients.
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients.
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible.
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component.
virtual std::unique_ptr< AccessibilityHandler > | createAccessibilityHandler ()
| Override this method to return a custom AccessibilityHandler for this component.
Public Member Functions inherited from juce::MouseListener
virtual | ~MouseListener ()=default
| Destructor.
Public Member Functions inherited from juce::ChangeBroadcaster
| ChangeBroadcaster () noexcept
| Creates an ChangeBroadcaster.
virtual | ~ChangeBroadcaster ()
| Destructor.
void | addChangeListener (ChangeListener *listener)
| Registers a listener to receive change callbacks from this broadcaster.
void | removeChangeListener (ChangeListener *listener)
| Unregisters a listener from the list.
void | removeAllChangeListeners ()
| Removes all listeners from the list.
void | sendChangeMessage ()
| Causes an asynchronous change message to be sent to all the registered listeners.
void | sendSynchronousChangeMessage ()
| Sends a synchronous change message to all the registered listeners.
void | dispatchPendingMessages ()
| If a change message has been sent but not yet dispatched, this will call sendSynchronousChangeMessage() to make the callback immediately.

## Additional Inherited Members

Static Public Member Functions inherited from juce::Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor.
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus.
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it.
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation.
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down.
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state.
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal.

## Member Enums

## ColourIds

enum juce::MidiKeyboardComponent::ColourIds

A set of colour IDs to use to change the colour of various aspects of the keyboard.

These constants can be used either via the Component::setColour(), or LookAndFeel::setColour() methods.

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
whiteNoteColourId |
blackNoteColourId |
keySeparatorLineColourId |
mouseOverKeyOverlayColourId | This colour will be overlaid on the normal note colour.
keyDownOverlayColourId | This colour will be overlaid on the normal note colour.
textLabelColourId |
shadowColourId |

## Constructors and Destructors

## MidiKeyboardComponent()

juce::MidiKeyboardComponent::MidiKeyboardComponent | ( | MidiKeyboardState & | state,
|  | Orientation | orientation )

Creates a MidiKeyboardComponent.

Parameters

  state | the midi keyboard model that this component will represent
  orientation | whether the keyboard is horizontal or vertical

## ~MidiKeyboardComponent()

juce::MidiKeyboardComponent::~MidiKeyboardComponent | ( |  | ) |

override

Destructor.

## Member Functions

## setVelocity()

void juce::MidiKeyboardComponent::setVelocity | ( | float | velocity,
|  | bool | useMousePositionForVelocity )

Changes the velocity used in midi note-on messages that are triggered by clicking on the component.

Values are 0 to 1.0, where 1.0 is the heaviest.

See also
  setMidiChannel

## setMidiChannel()

void juce::MidiKeyboardComponent::setMidiChannel | ( | int | midiChannelNumber | ) |

Changes the midi channel number that will be used for events triggered by clicking on the component.

The channel must be between 1 and 16 (inclusive). This is the channel that will be passed on to the MidiKeyboardState::noteOn() method when the user clicks the component.

Although this is the channel used for outgoing events, the component can display incoming events from more than one channel - see setMidiChannelsToDisplay()

See also
  setVelocity

## getMidiChannel()

int juce::MidiKeyboardComponent::getMidiChannel | ( |  | ) | const

inline noexcept

Returns the midi channel that the keyboard is using for midi messages.

See also
  setMidiChannel

## setMidiChannelsToDisplay()

void juce::MidiKeyboardComponent::setMidiChannelsToDisplay | ( | int | midiChannelMask | ) |

Sets a mask to indicate which incoming midi channels should be represented by key movements.

The mask is a set of bits, where bit 0 = midi channel 1, bit 1 = midi channel 2, etc.

If the MidiKeyboardState has a key down for any of the channels whose bits are set in this mask, the on-screen keys will also go down.

By default, this mask is set to 0xffff (all channels displayed).

See also
  setMidiChannel

## getMidiChannelsToDisplay()

int juce::MidiKeyboardComponent::getMidiChannelsToDisplay | ( |  | ) | const

inline noexcept

Returns the current set of midi channels represented by the component.

This is the value that was set with setMidiChannelsToDisplay().

## clearKeyMappings()

void juce::MidiKeyboardComponent::clearKeyMappings | ( |  | ) |

Deletes all key-mappings.

See also
  setKeyPressForNote

## setKeyPressForNote()

void juce::MidiKeyboardComponent::setKeyPressForNote | ( | const KeyPress & | key,
|  | int | midiNoteOffsetFromC )

Maps a key-press to a given note.

Parameters

  key | the key that should trigger the note
  midiNoteOffsetFromC | how many semitones above C the triggered note should be. The actual midi note that gets played will be this value + (12 * the current base octave). To change the base octave, see setKeyPressBaseOctave()

## removeKeyPressForNote()

void juce::MidiKeyboardComponent::removeKeyPressForNote | ( | int | midiNoteOffsetFromC | ) |

Removes any key-mappings for a given note.

For a description of what the note number means, see setKeyPressForNote().

## setKeyPressBaseOctave()

void juce::MidiKeyboardComponent::setKeyPressBaseOctave | ( | int | newOctaveNumber | ) |

Changes the base note above which key-press-triggered notes are played.

The set of key-mappings that trigger notes can be moved up and down to cover the entire scale using this method.

The value passed in is an octave number between 0 and 10 (inclusive), and indicates which C is the base note to which the key-mapped notes are relative.

## drawWhiteNote()

virtual void juce::MidiKeyboardComponent::drawWhiteNote | ( | int | midiNoteNumber,
|  | Graphics & | g,
|  | Rectangle< float > | area,
|  | bool | isDown,
|  | bool | isOver,
|  | Colour | lineColour,
|  | Colour | textColour )

virtual

Use this method to draw a white note of the keyboard in a given rectangle.

isOver indicates whether the mouse is over the key, isDown indicates whether the key is currently pressed down.

When doing this, be sure to note the keyboard's orientation.

## drawBlackNote()

virtual void juce::MidiKeyboardComponent::drawBlackNote | ( | int | midiNoteNumber,
|  | Graphics & | g,
|  | Rectangle< float > | area,
|  | bool | isDown,
|  | bool | isOver,
|  | Colour | noteFillColour )

virtual

Use this method to draw a black note of the keyboard in a given rectangle.

isOver indicates whether the mouse is over the key, isDown indicates whether the key is currently pressed down.

When doing this, be sure to note the keyboard's orientation.

## mouseDownOnKey()

virtual bool juce::MidiKeyboardComponent::mouseDownOnKey | ( | int | midiNoteNumber,
|  | const MouseEvent & | e )

virtual

Callback when the mouse is clicked on a key.

You could use this to do things like handle right-clicks on keys, etc.

Return true if you want the click to trigger the note, or false if you want to handle it yourself and not have the note played.

See also
  mouseDraggedToKey

## mouseDraggedToKey()

virtual bool juce::MidiKeyboardComponent::mouseDraggedToKey | ( | int | midiNoteNumber,
|  | const MouseEvent & | e )

virtual

Callback when the mouse is dragged from one key onto another.

Return true if you want the drag to trigger the new note, or false if you want to handle it yourself and not have the note played.

See also
  mouseDownOnKey

## mouseUpOnKey()

virtual void juce::MidiKeyboardComponent::mouseUpOnKey | ( | int | midiNoteNumber,
|  | const MouseEvent & | e )

virtual

Callback when the mouse is released from a key.

See also
  mouseDownOnKey

## getWhiteNoteText()

virtual String juce::MidiKeyboardComponent::getWhiteNoteText | ( | int | midiNoteNumber | ) |

virtual

Allows text to be drawn on the white notes.

By default this is used to label the C in each octave, but could be used for other things.

See also
  setOctaveForMiddleC

## mouseMove()

void juce::MidiKeyboardComponent::mouseMove | ( | const MouseEvent & | event | ) |

override virtual

Called when the mouse moves inside a component.

If the mouse button isn't pressed and the mouse moves over a component, this will be called to let the component react to this.

A component will always get a mouseEnter callback before a mouseMove.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseEnter, mouseExit, mouseDrag, contains

Reimplemented from juce::Component.

## mouseDrag()

void juce::MidiKeyboardComponent::mouseDrag | ( | const MouseEvent & | event | ) |

override virtual

Called when the mouse is moved while a button is held down.

When a mouse button is pressed inside a component, that component receives mouseDrag callbacks each time the mouse moves, even if the mouse strays outside the component's bounds.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseUp, mouseMove, contains, setDragRepeatInterval

Reimplemented from juce::Component.

## mouseDown()

void juce::MidiKeyboardComponent::mouseDown | ( | const MouseEvent & | event | ) |

override virtual

Called when a mouse button is pressed.

The MouseEvent object passed in contains lots of methods for finding out which button was pressed, as well as which modifier keys (e.g. shift, ctrl) were held down at the time.

Once a button is held down, the mouseDrag method will be called when the mouse moves, until the button is released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseUp, mouseDrag, mouseDoubleClick, contains

Reimplemented from juce::Component.

## mouseUp()

void juce::MidiKeyboardComponent::mouseUp | ( | const MouseEvent & | event | ) |

override virtual

Called when a mouse button is released.

A mouseUp callback is sent to the component in which a button was pressed even if the mouse is actually over a different component when the button is released.

The MouseEvent object passed in contains lots of methods for finding out which buttons were down just before they were released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseDrag, mouseDoubleClick, contains

Reimplemented from juce::Component.

## mouseEnter()

void juce::MidiKeyboardComponent::mouseEnter | ( | const MouseEvent & | event | ) |

override virtual

Called when the mouse first enters a component.

If the mouse button isn't pressed and the mouse moves into a component, this will be called to let the component react to this.

When the mouse button is pressed and held down while being moved in or out of a component, no mouseEnter or mouseExit callbacks are made - only mouseDrag messages are sent to the component that the mouse was originally clicked on, until the button is released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseExit, mouseDrag, mouseMove, contains

Reimplemented from juce::Component.

## mouseExit()

void juce::MidiKeyboardComponent::mouseExit | ( | const MouseEvent & | event | ) |

override virtual

Called when the mouse moves out of a component.

This will be called when the mouse moves off the edge of this component.

If the mouse button was pressed, and it was then dragged off the edge of the component and released, then this callback will happen when the button is released, after the mouseUp callback.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseEnter, mouseDrag, mouseMove, contains

Reimplemented from juce::Component.

## timerCallback()

void juce::MidiKeyboardComponent::timerCallback | ( |  | ) |

override virtual

The user-defined callback routine that actually gets called periodically.

It's perfectly ok to call startTimer() or stopTimer() from within this callback to change the subsequent intervals.

Implements juce::Timer.

## keyStateChanged()

bool juce::MidiKeyboardComponent::keyStateChanged | ( | bool | isKeyDown | ) |

override virtual

Called when a key is pressed or released.

Whenever a key on the keyboard is pressed or released (including modifier keys like shift and ctrl), this method will be called on the component that currently has the keyboard focus. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, then any KeyListeners that have been registered with this component will have their keyStateChanged methods called. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

To find out which keys are up or down at any time, see the KeyPress::isKeyCurrentlyDown() method.

Parameters

  isKeyDown | true if a key has been pressed; false if it has been released

See also
  keyPressed, KeyPress, getCurrentlyFocusedComponent, addKeyListener

Reimplemented from juce::Component.

## keyPressed()

bool juce::MidiKeyboardComponent::keyPressed | ( | const KeyPress & | key | ) |

override virtual

Called when a key is pressed.

When a key is pressed, the component that has the keyboard focus will have this method called. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, the key will be passed to any KeyListeners that have been registered with this component. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

See also
  keyStateChanged, getCurrentlyFocusedComponent, addKeyListener

Reimplemented from juce::Component.

## focusLost()

void juce::MidiKeyboardComponent::focusLost | ( | FocusChangeType | cause | ) |

override virtual

Called to indicate that this component has just lost the keyboard focus.

See also
  focusGained, setWantsKeyboardFocus, getCurrentlyFocusedComponent, hasKeyboardFocus

Reimplemented from juce::Component.

## colourChanged()

void juce::MidiKeyboardComponent::colourChanged | ( |  | ) |

override virtual

This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChange() methods.

See also
  setColour, findColour, setLookAndFeel, sendLookAndFeelChange

Reimplemented from juce::Component.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited